using System;
using System.Collections.Generic;
using System.Text;
using System.IO;
using System.Windows.Forms;

namespace HL7Viewer
{
    public class HL7DataSet
    {
        public string[] dataFields;

        public HL7DataSet()
        {
        }

        public void SetSegmentNames()
        {
            bool setPrefix = false;

            for( int i = 0; i < dataFields.Length; i ++ )
            {
                if( dataFields[i] == "EVN" ) setPrefix = true; // Event Type Segment 
                if( dataFields[i] == "PID" ) setPrefix = true; // Patient Identification Segment 
                if( dataFields[i] == "PV1" ) setPrefix = true; // Patient Visit Segment 
                if( dataFields[i] == "PV2" ) setPrefix = true; // Patient Visit - Additional Information Segment 
                if( dataFields[i] == "NK1" ) setPrefix = true; // Next of Kin / Associated Parties Segment 
                if( dataFields[i] == "AL1" ) setPrefix = true; // Patient Allergy Information Segment 
                if( dataFields[i] == "IAM" ) setPrefix = true; // Patient Adverse Reaction Information Segment - Unique Identifier 
                if( dataFields[i] == "NPU" ) setPrefix = true; // Bed Status Update Segment
                if( dataFields[i] == "MRG" ) setPrefix = true; // Merge Patient Information Segment
                if( dataFields[i] == "PD1" ) setPrefix = true; // Patient Additional Demographic Segment
                if( dataFields[i] == "DB1" ) setPrefix = true; // Disability Segment
                if( dataFields[i] == "PDA" ) setPrefix = true; // Patient Death and Autopsy Segment

                // General Segments

                if( dataFields[i] == "ORC" ) setPrefix = true; // Common Order Segment 
                if( dataFields[i] == "BLG" ) setPrefix = true; // Billing Segment 
                if( dataFields[i] == "OBR" ) setPrefix = true; // Observation Request Segment 
                if( dataFields[i] == "OBX" ) setPrefix = true; // Oberservation Results
                if( dataFields[i] == "TQ1" ) setPrefix = true; // Timing/Quantity Segment 
                if( dataFields[i] == "TQ2" ) setPrefix = true; // Timing/Quantity Relationship 
                if( dataFields[i] == "IPC" ) setPrefix = true; // Imaging Procedure Control Segment 
                if( dataFields[i] == "SPM" ) setPrefix = true; // Specimen Segment

                // Diet Trigger

                if( dataFields[i] == "OMD" ) setPrefix = true; // Dietary Order (Event O03) 
                if( dataFields[i] == "ORD" ) setPrefix = true; // dietary order acknowledgment (Event O04) 

                // Diet Segments

                if( dataFields[i] == "ODS" ) setPrefix = true; // dietary orders, supplements, and preferences segment 
                if( dataFields[i] == "ODT" ) setPrefix = true; // diet tray instructions segment 

                // Supply Segments

                if( dataFields[i] == "RQD" ) setPrefix = true; // Requisition Detail Segment 
                if( dataFields[i] == "RQ1" ) setPrefix = true; // Requisition Detail-1 Segment 

                // Message Control

                if( dataFields[i] == "ACK" ) setPrefix = true;
                if( dataFields[i] == "MCF" ) setPrefix = true;
                if( dataFields[i] == "ADD" ) setPrefix = true;
                if( dataFields[i] == "BHS" ) setPrefix = true;
                if( dataFields[i] == "BTS" ) setPrefix = true;
                if( dataFields[i] == "DSC" ) setPrefix = true;
                if( dataFields[i] == "FHS" ) setPrefix = true;
                if( dataFields[i] == "FTS" ) setPrefix = true;
                if( dataFields[i] == "MSA" ) setPrefix = true;
                if( dataFields[i] == "MSH" ) setPrefix = true;
                if( dataFields[i] == "NTE" ) setPrefix = true;
                if( dataFields[i] == "OVR" ) setPrefix = true;
                if( dataFields[i] == "SFT" ) setPrefix = true;

                // Pharmacy

                if( dataFields[i] == "OMP" ) setPrefix = true;
                if( dataFields[i] == "ORP" ) setPrefix = true;
                if( dataFields[i] == "RDE" ) setPrefix = true;
                if( dataFields[i] == "RRE" ) setPrefix = true;
                if( dataFields[i] == "RDS" ) setPrefix = true;
                if( dataFields[i] == "RRD" ) setPrefix = true;
                if( dataFields[i] == "RGV" ) setPrefix = true;
                if( dataFields[i] == "RRG" ) setPrefix = true;
                if( dataFields[i] == "RAS" ) setPrefix = true;
                if( dataFields[i] == "RRA" ) setPrefix = true;
                if( dataFields[i] == "RDE" ) setPrefix = true;
                if( dataFields[i] == "RRE" ) setPrefix = true;
                if( dataFields[i] == "ROR" ) setPrefix = true;
                if( dataFields[i] == "RAR" ) setPrefix = true;
                if( dataFields[i] == "RDR" ) setPrefix = true;
                if( dataFields[i] == "RER" ) setPrefix = true;
                if( dataFields[i] == "RGR" ) setPrefix = true;

                // Pharmacy Threatments

                if( dataFields[i] == "RXO" ) setPrefix = true;
                if( dataFields[i] == "RXR" ) setPrefix = true;
                if( dataFields[i] == "RXC" ) setPrefix = true;
                if( dataFields[i] == "RXD" ) setPrefix = true;
                if( dataFields[i] == "RQG" ) setPrefix = true;
                if( dataFields[i] == "RXA" ) setPrefix = true;
                
                // Vaccine Triggers

                if( dataFields[i] == "VXQ" ) setPrefix = true;
                if( dataFields[i] == "VXX" ) setPrefix = true;
                if( dataFields[i] == "VXR" ) setPrefix = true;
                if( dataFields[i] == "VXU" ) setPrefix = true;

                // Transfusion Service

                if( dataFields[i] == "BPO" ) setPrefix = true;
                if( dataFields[i] == "BPX" ) setPrefix = true;
                if( dataFields[i] == "BTX" ) setPrefix = true;

                // Query/Response Message Segments

                if( dataFields[i] == "DSP" ) setPrefix = true;
                if( dataFields[i] == "QAK" ) setPrefix = true;
                if( dataFields[i] == "QID" ) setPrefix = true;
                if( dataFields[i] == "QPD" ) setPrefix = true;
                if( dataFields[i] == "QRI" ) setPrefix = true;
                if( dataFields[i] == "RCP" ) setPrefix = true;
                if( dataFields[i] == "RDF" ) setPrefix = true;
                if( dataFields[i] == "RDT" ) setPrefix = true;

                // Other Query/Response Segments

                if( dataFields[i] == "EQL" ) setPrefix = true;
                if( dataFields[i] == "ERQ" ) setPrefix = true;
                if( dataFields[i] == "QRD" ) setPrefix = true;
                if( dataFields[i] == "QRF" ) setPrefix = true;
                if( dataFields[i] == "SPR" ) setPrefix = true;
                if( dataFields[i] == "URD" ) setPrefix = true;
                if( dataFields[i] == "URS" ) setPrefix = true;
                if( dataFields[i] == "VTQ" ) setPrefix = true;

                // Financial Transaction Segment

                if( dataFields[i] == "FT1" ) setPrefix = true;
                if( dataFields[i] == "DG1" ) setPrefix = true;
                if( dataFields[i] == "DRG" ) setPrefix = true;
                if( dataFields[i] == "PR1" ) setPrefix = true;
                if( dataFields[i] == "RQD" ) setPrefix = true;
                if( dataFields[i] == "IN1" ) setPrefix = true;
                if( dataFields[i] == "IN2" ) setPrefix = true;
                if( dataFields[i] == "IN3" ) setPrefix = true;
                if( dataFields[i] == "ACC" ) setPrefix = true;
                if( dataFields[i] == "UB1" ) setPrefix = true;
                if( dataFields[i] == "UB2" ) setPrefix = true;
                if( dataFields[i] == "ABS" ) setPrefix = true;
                if( dataFields[i] == "BLC" ) setPrefix = true;
                if( dataFields[i] == "RMI" ) setPrefix = true;
                if( dataFields[i] == "GP1" ) setPrefix = true;
                if( dataFields[i] == "GP2" ) setPrefix = true;

                // Clinical Trials

                if( dataFields[i] == "CSR" ) setPrefix = true;
                if( dataFields[i] == "CSP" ) setPrefix = true;
                if( dataFields[i] == "CSS" ) setPrefix = true;
                if( dataFields[i] == "CTI" ) setPrefix = true;
                if( dataFields[i] == "CM0" ) setPrefix = true;
                if( dataFields[i] == "CM1" ) setPrefix = true;
                if( dataFields[i] == "CM2" ) setPrefix = true;

                // Product Experience

                if( dataFields[i] == "PES" ) setPrefix = true;
                if( dataFields[i] == "PEO" ) setPrefix = true;
                if( dataFields[i] == "PCR" ) setPrefix = true;
                if( dataFields[i] == "PSH" ) setPrefix = true;
                if( dataFields[i] == "PDC" ) setPrefix = true;
                if( dataFields[i] == "FAC" ) setPrefix = true;

                // General Master File

                if( dataFields[i] == "MFI" ) setPrefix = true;
                if( dataFields[i] == "MFE" ) setPrefix = true;
                if( dataFields[i] == "MFA" ) setPrefix = true;
                if( dataFields[i] == "ZL7" ) setPrefix = true;

                // Service Segments

                if( dataFields[i] == "OM1" ) setPrefix = true;
                if( dataFields[i] == "OM2" ) setPrefix = true;
                if( dataFields[i] == "OM3" ) setPrefix = true;
                if( dataFields[i] == "OM4" ) setPrefix = true;
                if( dataFields[i] == "OM5" ) setPrefix = true;
                if( dataFields[i] == "OM6" ) setPrefix = true;
                if( dataFields[i] == "OM7" ) setPrefix = true;

                // Location Master Files

                if( dataFields[i] == "LOC" ) setPrefix = true;
                if( dataFields[i] == "LCH" ) setPrefix = true;
                if( dataFields[i] == "LRL" ) setPrefix = true;
                if( dataFields[i] == "LDP" ) setPrefix = true;
                if( dataFields[i] == "LCC" ) setPrefix = true;

                // Charge Description

                if( dataFields[i] == "CDM" ) setPrefix = true;
                if( dataFields[i] == "PRC" ) setPrefix = true;
                if( dataFields[i] == "CM0" ) setPrefix = true;
                if( dataFields[i] == "CM1" ) setPrefix = true;
                if( dataFields[i] == "CM2" ) setPrefix = true;
                
                // Inventory Item Master

                if( dataFields[i] == "IIM" ) setPrefix = true;
                
                // Medical Records

                if( dataFields[i] == "TXA" ) setPrefix = true;
                if( dataFields[i] == "CON" ) setPrefix = true;
               
                // Appointment Request

                if( dataFields[i] == "ARQ" ) setPrefix = true;
                if( dataFields[i] == "SCH" ) setPrefix = true;
                if( dataFields[i] == "RGS" ) setPrefix = true;
                if( dataFields[i] == "AIS" ) setPrefix = true;
                if( dataFields[i] == "AIG" ) setPrefix = true;
                if( dataFields[i] == "AIL" ) setPrefix = true;
                if( dataFields[i] == "AIP" ) setPrefix = true;
                if( dataFields[i] == "APR" ) setPrefix = true;

                // Patient Referal

                if( dataFields[i] == "RF1" ) setPrefix = true;
                if( dataFields[i] == "AUT" ) setPrefix = true;
                if( dataFields[i] == "PRD" ) setPrefix = true;
                if( dataFields[i] == "CTD" ) setPrefix = true;
                
                // Patient Care

                if( dataFields[i] == "GOL" ) setPrefix = true;
                if( dataFields[i] == "PRB" ) setPrefix = true;
                if( dataFields[i] == "PTH" ) setPrefix = true;
                if( dataFields[i] == "VAR" ) setPrefix = true;
                
                // Clinical Laboratory

                if( dataFields[i] == "EQU" ) setPrefix = true;
                if( dataFields[i] == "ISD" ) setPrefix = true;
                if( dataFields[i] == "SAC" ) setPrefix = true;
                if( dataFields[i] == "INV" ) setPrefix = true;
                if( dataFields[i] == "ECD" ) setPrefix = true;
                if( dataFields[i] == "ECR" ) setPrefix = true;
                if( dataFields[i] == "NDS" ) setPrefix = true;
                if( dataFields[i] == "CNS" ) setPrefix = true;
                if( dataFields[i] == "TCC" ) setPrefix = true;
                if( dataFields[i] == "TCD" ) setPrefix = true;
                if( dataFields[i] == "SID" ) setPrefix = true;
                if( dataFields[i] == "EQP" ) setPrefix = true;

                // Application Management

                if( dataFields[i] == "NCK" ) setPrefix = true;
                if( dataFields[i] == "NSC" ) setPrefix = true;
                if( dataFields[i] == "NST" ) setPrefix = true;
                
                // Personal Management

                if( dataFields[i] == "AFF" ) setPrefix = true;
                if( dataFields[i] == "CER" ) setPrefix = true;
                if( dataFields[i] == "EDU" ) setPrefix = true;
                if( dataFields[i] == "LAN" ) setPrefix = true;
                if( dataFields[i] == "ORG" ) setPrefix = true;
                if( dataFields[i] == "PRA" ) setPrefix = true;
                if( dataFields[i] == "ROL" ) setPrefix = true;
                if( dataFields[i] == "STF" ) setPrefix = true;

                if( setPrefix )
                {                    
                    dataFields[i] = "[PREFIX]" + dataFields[i];
                }

                setPrefix = false;
            }
        }
    }

    public class HL7FileReader : StreamReader
    {
        private string[] fileLines;
        private int fileLineIndex;
        private int fileLinesTotal;
        private string filter;

        public HL7FileReader( string fileName ) : base( fileName, Encoding.Default )
        {
            char[] readBuffer;
            string[] newFileLines;

            readBuffer = new char[BaseStream.Length];
            Read( readBuffer, 0, ( int ) BaseStream.Length );

            // 
            // Wir mssen analysieren bei welchen Feldern es sich um Message Segments handelt
            // bei e*Gate wird vor dem Namen des Message Segments ein \x0D gestellt, dies stellt
            // allerdings keinen HL7 Standard dar.
            // Wir mssen dementsprechend nach dem einlesen alle Zeilen durchsuchen
            // und die Prefixe einsetzen (nach HL7 2.5)
            //
            newFileLines = new string( readBuffer ).Replace( "\r", "|" ).Split( "\n".ToCharArray());
            if( IsHl7DataFile( newFileLines[0] ))
            {
                fileLines = newFileLines;
            }
            else
            {
                throw new Exception( "IllegalFileFormat" );           
            }

            fileLineIndex = 0;
            fileLinesTotal = fileLines.Length-1;
            filter = null;

            Close();
        }

        public HL7DataSet GetFirstDataset
        {
            get
            {
                HL7DataSet dataSet = new HL7DataSet();

                try
                {
                    dataSet.dataFields = GetFirstLine.Split( "|".ToCharArray() );
                    dataSet.SetSegmentNames();
                    return dataSet;
                }
                catch( Exception e )
                {
                    return null;
                }
            }
        }

        public HL7DataSet GetLastDataset
        {
            get
            {
                HL7DataSet dataSet = new HL7DataSet();

                try
                {
                    dataSet.dataFields = GetLastLine.Split( "|".ToCharArray() );
                    dataSet.SetSegmentNames();
                    return dataSet;
                }
                catch( Exception e )
                {
                    return null;
                }
            }
        }

        public HL7DataSet GetNextDataset
        {
            get
            {
                HL7DataSet dataSet = new HL7DataSet();

                try
                {
                    dataSet.dataFields = GetNextLine.Split( "|".ToCharArray() );
                    dataSet.SetSegmentNames();
                    return dataSet;
                }
                catch( Exception e )
                {
                    return null;
                }
            }
        }

        public HL7DataSet GetPrevDataset
        {
            get
            {
                HL7DataSet dataSet = new HL7DataSet();

                try
                {
                    dataSet.dataFields = GetPrevLine.Split( "|".ToCharArray() );
                    dataSet.SetSegmentNames();
                    return dataSet;
                }
                catch( Exception e )
                {
                    return null;
                }
            }
        }

        public int GetNumDatasets
        {
            get
            {
                return fileLinesTotal;
            }
        }

        public int GetCurDatasetIndex
        {
            get
            {
                return fileLineIndex;
            }
        }

        public string Filter
        {
           set
           {
               if( value != "" )
               {
                   filter = value;
               }
               else
               {
                   filter = null;
               }
           }

           get
           {
               if( filter == null )
               {
                   return "";
               }
               else
               {
                   return filter;
               }
           }
        }

        public void ResetFilter()
        {
            filter = null;
        }

        private string GetPrevLine
        {
            get
            {
                if( fileLineIndex > 0 )
                {
                    fileLineIndex--;
                    if( filter != null )
                    {
                        int prevFileLineIndex = fileLineIndex + 1;
                        while(( fileLineIndex > 0 ) && ! fileLines[fileLineIndex].Contains( filter ))
                        {
                            fileLineIndex --;
                        }

                        if(( fileLineIndex == 0 ) && ! fileLines[fileLineIndex].Contains( filter ))
                        {
                            fileLineIndex = prevFileLineIndex;
                        }

                        return fileLines[fileLineIndex];
                    }
                    else
                    {
                        return fileLines[fileLineIndex];
                    }
                }
                else
                {
                    return null;
                }
            }
        }

        private string GetNextLine
        {
            get
            {
                if( fileLineIndex < fileLinesTotal )
                {
                    fileLineIndex++;
                    if( filter != null )
                    {
                        while(( fileLineIndex < fileLinesTotal ) && ! fileLines[fileLineIndex].Contains( filter ))
                        {
                            fileLineIndex ++;
                        }

                        if( fileLineIndex >= fileLinesTotal ) return "";
                        return fileLines[fileLineIndex];
                    }
                    else
                    {
                        return fileLines[fileLineIndex];
                    }
                }
                else
                {
                    return null;
                }
            }
        }

        private string GetFirstLine
        {
            get
            {
                fileLineIndex = 0;                

                if( filter != null )
                {
                    while(( fileLineIndex < fileLinesTotal ) && ! fileLines[fileLineIndex].Contains( filter ))
                    {
                        fileLineIndex ++;
                    }

                    if( fileLineIndex >= fileLinesTotal )
                    {
                        MessageBox.Show( "Keine Daten gefunden, lsche Filter", "Information", MessageBoxButtons.OK, MessageBoxIcon.Information );
                        filter = null;
                        fileLineIndex = 0;
                    }

                    return fileLines[fileLineIndex];
                }
                else
                {                    
                    return fileLines[fileLineIndex];
                }
            }
        }

        private string GetLastLine
        {
            get
            {
                fileLineIndex = fileLinesTotal-1;

                if( filter != null )
                {
                    while(( fileLineIndex >= 0 ) && ! fileLines[fileLineIndex].Contains( filter ))
                    {
                        fileLineIndex --;
                    }                   

                    return fileLines[fileLineIndex];
                }
                else
                {                             
                    return fileLines[fileLineIndex];
                }
            }
        }

        private bool IsHl7DataFile( string firstLine )
        {
            if( firstLine.IndexOf( "MSH" ) == -1 ) return false;
            return true;
        }
    }
}
