using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

namespace HL7Viewer
{
    public partial class Filter : Form
    {
        HL7FileReader hl7DataFile;
        private DialogResult filterDialogResult;

        public Filter()
        {
            InitializeComponent();
        }

        public Filter( HL7FileReader hl7DataFile ) : this()
        {
            this.hl7DataFile = hl7DataFile;
            textBox1.Text = hl7DataFile.Filter;
            textBox1.TabIndex = 0;
        }

        // Button: Abbrechen
        private void button2_Click( object sender, EventArgs e )
        {
            filterDialogResult = DialogResult.Abort;
            this.Close();
        }

        // Button: Filter lschen
        private void button3_Click( object sender, EventArgs e )
        { 
            filterDialogResult = DialogResult.OK;
            hl7DataFile.ResetFilter();
            this.Close();
        }

        // Button: Filter setzen
        private void button1_Click( object sender, EventArgs e )
        {
            if( textBox1.Text != "" )
            {
                hl7DataFile.Filter = textBox1.Text;
            }
            filterDialogResult = DialogResult.OK;
            this.Close();
        }

        // ShowDialog() 
        public new DialogResult ShowDialog()
        {
            base.ShowDialog();

            return filterDialogResult;
        }
    }
}